"use strict";

const astUtil = require("./util/ast");

const ATTRIBUTES = {
  OBJ: 'obj'
};

module.exports = function (babel) {
  const types = babel.types;
  return function (path) {
    const node = path.node;
    const attributes = astUtil.getAttributeMap(node);
    const children = astUtil.getChildren(types, node);
    const returnExpression = astUtil.getSanitizedExpressionForContent(types, children);
    const mapParams = [];

    if (!attributes[ATTRIBUTES.OBJ]) {
      return;
    }

    mapParams.push(types.Identifier('obj'));
    return types.callExpression(types.memberExpression(types.arrayExpression([astUtil.getExpression(attributes[ATTRIBUTES.OBJ])]), types.identifier('map')), [types.functionExpression(null, mapParams, types.blockStatement([types.returnStatement(returnExpression)])), types.identifier('this')]);
  };
};