'use strict';
const transformFor = require("./forStatement");
const transformIf = require("./ifStatement");
const transformWith = require("./withStatement");

export default function(babel) {

  const handlers = {
    'for': transformFor(babel),
    'if': transformIf(babel),
    'with': transformWith(babel),
  }

  return {
      visitor: {
        JSXElement(path) {
          const nodeName = path.node.openingElement.name.name;
          const handler = handlers[nodeName];

          if(handler){
            path.replaceWith(handler(path));
          }
        }
      }
  };
};