import jsxPlus from '../src/index';
import { expect } from 'chai';
const React = require('react');
const ReactDOMServer = require('react-dom/server');

require('@babel/register')({
  presets: ['@babel/preset-react'],
  plugins: [
    jsxPlus
  ],
  cache: false
});

describe('if测试', function() {
  const sample = require('./sample/if.jsx');

  // const {code} = require('@babel/core').transform(`
  // const React = require('react');
  // const createReactClass = require('create-react-class');
  
  // module.exports = createReactClass({
  //   render: function () {
  //     return (
  //       <div>
  //         <if condition={\`${this}.props.condition === 'testIf'\`}>
  //           <span>IfBlock</span>
  //         </if>
  //       </div>
  //     );
  //   }
  // });
  // `, {presets: ['@babel/preset-react'],plugins: [jsxPlus]})
  // console.log(code)

  it('条件为true测试', function() {
    const el = React.createElement(sample, { test: true });
    const renderred = ReactDOMServer.renderToString(el);
    console.log(renderred)
    expect(renderred).to.contain('IfBlock');
  });


  it('条件为false测试', function() {
    const el = React.createElement(sample, { test: false });
    const renderred = ReactDOMServer.renderToString(el);
    console.log(renderred)
    expect(renderred).to.contain('ElseBlock');
  });
});

describe('for测试', function() {
  const { arraySample, objectSample } = require('./sample/for.jsx');

  it('Array遍历测试', function() {
    const el = React.createElement(arraySample, { 
      items: [
        { 
          name: 'item-1', 
          list: [ 
            { name: 'item-1-1' },
            { name: 'item-1-2' }
          ] 
        },
        { name: 'item-2' }
      ]
    });

    const renderred = ReactDOMServer.renderToString(el);
    console.log(renderred)
    expect(renderred).to.contain('item-2');
  });

  it('Object遍历测试', function() {
    const el = React.createElement(objectSample, { 
      items: {
        name1: 'item-1',
        name2: 'item-2'
      }
    });

    const renderred = ReactDOMServer.renderToString(el);
    console.log(renderred)
    expect(renderred).to.contain('item-2');
  });
});

describe('with测试', function() {
  const sample = require('./sample/with.jsx');

  it('Object测试', function() {
    const el = React.createElement(sample, { 
      item: {
        title: '标题',
        subTitle: '副标题'
      }
    });

    const renderred = ReactDOMServer.renderToString(el);
    console.log(renderred)
    expect(renderred).to.contain('<h1');
  });
});

